lists.openwall.net   lists  /  announce  owl-users  owl-dev  john-users  john-dev  passwdqc-users  yescrypt  popa3d-users  /  oss-security  kernel-hardening  musl  sabotage  tlsify  passwords  /  crypt-dev  xvendor  /  Bugtraq  Full-Disclosure  linux-kernel  linux-netdev  linux-ext4  linux-hardening  linux-cve-announce  PHC 
Open Source and information security mailing list archives
 
Hash Suite: Windows password security audit tool. GUI, reports in PDF.
[<prev] [next>] [day] [month] [year] [list]
Message-ID: <20241118231534.1351938-1-masahiroy@kernel.org>
Date: Tue, 19 Nov 2024 08:09:06 +0900
From: Masahiro Yamada <masahiroy@...nel.org>
To: linux-kbuild@...r.kernel.org
Cc: Rasmus Villemoes <linux@...musvillemoes.dk>,
	Masahiro Yamada <masahiroy@...nel.org>,
	linux-kernel@...r.kernel.org
Subject: [PATCH] setlocalversion: add -e option

Set the -e option to ensure this script fails on any unexpected errors.

Without this change, the kernel build may continue running with an
incorrect string in include/config/kernel.release.

Currently, try_tag() returns 1 when the expected tag is not found as an
ancestor, but this is a case where the script should continue.

Signed-off-by: Masahiro Yamada <masahiroy@...nel.org>
---

After '[PATCH v3] setlocalversion: work around "git describe" performance',
I need to remove "|| return 1" statements anyway, as it is not suitable
for the -e option.

  if []; then
      ...
  fi

is more consistent with the existing code.



 scripts/setlocalversion | 12 ++++++++----
 1 file changed, 8 insertions(+), 4 deletions(-)

diff --git a/scripts/setlocalversion b/scripts/setlocalversion
index 5818465abba9..28169d7e143b 100755
--- a/scripts/setlocalversion
+++ b/scripts/setlocalversion
@@ -10,6 +10,8 @@
 #
 #
 
+set -e
+
 usage() {
 	echo "Usage: $0 [--no-local] [srctree]" >&2
 	exit 1
@@ -34,7 +36,9 @@ try_tag() {
 	tag="$1"
 
 	# Is $tag an annotated tag?
-	[ "$(git cat-file -t "$tag" 2> /dev/null)" = tag ] || return 1
+	if [ "$(git cat-file -t "$tag" 2> /dev/null)" != tag ]; then
+		 return
+	fi
 
 	# Is it an ancestor of HEAD, and if so, how many commits are in $tag..HEAD?
 	# shellcheck disable=SC2046 # word splitting is the point here
@@ -43,12 +47,12 @@ try_tag() {
 	# $1 is 0 if and only if $tag is an ancestor of HEAD. Use
 	# string comparison, because $1 is empty if the 'git rev-list'
 	# command somehow failed.
-	[ "$1" = 0 ] || return 1
+	if [ "$1" != 0 ]; then
+		return
+	fi
 
 	# $2 is the number of commits in the range $tag..HEAD, possibly 0.
 	count="$2"
-
-	return 0
 }
 
 scm_version()
-- 
2.43.0


Powered by blists - more mailing lists

Powered by Openwall GNU/*/Linux Powered by OpenVZ